%define glib2_version 2.44.0

Name:           dconf
Version:        0.28.0
Release:        4%{?dist}
Summary:        A configuration system

License:        LGPLv2+ and GPLv2+ and GPLv3+
URL:            http://live.gnome.org/dconf
Source0:        http://download.gnome.org/sources/dconf/0.28/dconf-%{version}.tar.xz

Patch0:         dconf-0.28.0-db-mtime.patch
Patch1:         0001-Engine-track-in-progress-watch-handles-to-avoid-spur.patch
Patch2:         0001-Engine-add-some-missing-objects-to-dconf_engine_unre.patch
Patch3:         0002-Engine-extend-subscriptions-state-to-account-for-mul.patch
Patch4:         0003-Engine-add-g_debug-statements-in-state-changing-inte.patch
Patch5:         0004-Engine-Add-locks-around-access-to-subscription-count.patch
Patch6:         0005-Engine-Add-comprehensive-unit-tests-for-subscription.patch
Patch7:         0001-Engine-Change-overflow-thresholds-in-subscription-co.patch
Patch8:         dconf-0.28.0-permissions.patch

BuildRequires:  glib2-devel >= %{glib2_version}
BuildRequires:  gtk-doc
BuildRequires:  meson
BuildRequires:  vala

Requires:       dbus
Requires:       glib2%{?_isa} >= %{glib2_version}

%description
dconf is a low-level configuration system. Its main purpose is to provide a
backend to the GSettings API in GLib.

%package devel
Summary: Header files and libraries for dconf development
Requires: %{name}%{?_isa} = %{version}-%{release}

%description devel
dconf development package. Contains files needed for doing software
development using dconf.

%prep
%autosetup -p1

%build
%meson -Denable-gtk-doc=true
%meson_build

%install
%meson_install

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dconf/profile

cat << EOF > $RPM_BUILD_ROOT%{_sysconfdir}/dconf/profile/user
user-db:user
system-db:local
system-db:site
system-db:distro
EOF

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dconf/db/local.d/locks
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dconf/db/site.d/locks
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dconf/db/distro.d/locks

%posttrans
dconf update

%files
%license COPYING
%dir %{_sysconfdir}/dconf
%dir %{_sysconfdir}/dconf/db
%dir %{_sysconfdir}/dconf/db/local.d
%dir %{_sysconfdir}/dconf/db/local.d/locks
%dir %{_sysconfdir}/dconf/db/site.d
%dir %{_sysconfdir}/dconf/db/site.d/locks
%dir %{_sysconfdir}/dconf/db/distro.d
%dir %{_sysconfdir}/dconf/db/distro.d/locks
%dir %{_sysconfdir}/dconf/profile
%{_libdir}/gio/modules/libdconfsettings.so
%{_libexecdir}/dconf-service
%{_datadir}/dbus-1/services/ca.desrt.dconf.service
%{_bindir}/dconf
%{_libdir}/libdconf.so.1*
%{_datadir}/bash-completion/completions/dconf
%{_mandir}/man1/dconf-service.1.gz
%{_mandir}/man1/dconf.1.gz
%{_mandir}/man7/dconf.7.gz
%config(noreplace) %{_sysconfdir}/dconf/profile/user

%files devel
%{_includedir}/dconf
%{_libdir}/libdconf.so
%{_libdir}/pkgconfig/dconf.pc
%dir %{_datadir}/gtk-doc
%dir %{_datadir}/gtk-doc/html
%{_datadir}/gtk-doc/html/dconf
%{_datadir}/vala

%changelog
* Mon Nov 23 2020 Marek Kasik <mkasik@redhat.com> - 0.28.0-4
- Restore permissions on updated database
- Resolves: #1879722

* Fri Jan 18 2019 Olivier Fourdan <ofourdan@redhat.com> - 0.28.0-3
- Backport fix for emission of spurious changed signals
- for all keys at once crashing gnome-shell
- Resolves: #1666176

* Wed Jul 25 2018 Marek Kasik <mkasik@redhat.com> - 0.28.0-2
- Check mtimes of files in /etc/dconf/db/*.d/ directories
- when running "dconf update"
- Related: #1570569

* Tue Mar 13 2018 Kalev Lember <klember@redhat.com> - 0.28.0-1
- Update to 0.28.0

* Mon Mar 12 2018 Kalev Lember <klember@redhat.com> - 0.27.1-1
- Update to 0.27.1
- Switch to the meson build system
- Don't set group tags
- Remove obsolete rpm scriptlets
- Fix gtk-doc directory ownership
- Tighten soname glob

* Mon Feb 19 2018 Ray Strode <rstrode@redhat.com> - 0.26.1-3
- Add systemd dbs for distro, site, and machine local dconf databases
  Resolves: #1546644

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.26.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Oct 09 2017 Kalev Lember <klember@redhat.com> - 0.26.1-1
- Update to 0.26.1

* Wed Aug 02 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.26.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.26.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Tue Mar 21 2017 Colin Walters <walters@verbum.org> - 0.26.0-3
- Backport patch to work around gtype threading

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.26.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Mar 23 2016 Kalev Lember <klember@redhat.com> - 0.26.0-1
- Update to 0.26.0

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.25.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Dec 16 2015 Kalev Lember <klember@redhat.com> - 0.25.1-1
- Update to 0.25.1

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.24.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Mar 23 2015 Kalev Lember <kalevlember@gmail.com> - 0.24.0-1
- Update to 0.24.0

* Tue Mar 17 2015 Kalev Lember <kalevlember@gmail.com> - 0.23.2-1
- Update to 0.23.2

* Mon Mar 02 2015 Kalev Lember <kalevlember@gmail.com> - 0.23.1-1
- Update to 0.23.1
- This drops the -editor subpackage which now lives in a separate
  dconf-editor SRPM.
- Use the %%license macro for the COPYING file

* Sat Feb 21 2015 Till Maas <opensource@till.name> - 0.22.0-2
- Rebuilt for Fedora 23 Change
  https://fedoraproject.org/wiki/Changes/Harden_all_packages_with_position-independent_code

* Fri Sep 19 2014 Kalev Lember <kalevlember@gmail.com> - 0.22.0-1
- Update to 0.22.0

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.21.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Tue Jul 22 2014 Kalev Lember <kalevlember@gmail.com> - 0.21.0-1
- Update to 0.21.0

* Fri Jul 11 2014 Parag <paragn AT fedoraproject DOT org> - 0.20.0-4
- Fix the directory ownership (rh#1056020)

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.20.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat Apr 05 2014 Kalev Lember <kalevlember@gmail.com> - 0.20.0-2
- Specify minimum glib version

* Mon Mar 24 2014 Richard Hughes <rhughes@redhat.com> - 0.20.0-1
- Update to 0.20.0

* Tue Mar 18 2014 Richard Hughes <rhughes@redhat.com> - 0.19.92-1
- Update to 0.19.92

* Tue Mar 04 2014 Richard Hughes <rhughes@redhat.com> - 0.19.91-1
- Update to 0.19.91

* Tue Feb 18 2014 Richard Hughes <rhughes@redhat.com> - 0.19.90-1
- Update to 0.19.90

* Tue Jan 14 2014 Richard Hughes <rhughes@redhat.com> - 0.19.3-1
- Update to 0.19.3

* Thu Nov 14 2013 Richard Hughes <rhughes@redhat.com> - 0.19.2-1
- Update to 0.19.2

* Thu Sep 26 2013 Kalev Lember <kalevlember@gmail.com> - 0.18.0-2
- Add missing glib-compile-schemas scriptlets to the -editor subpackage

* Tue Sep 24 2013 Kalev Lember <kalevlember@gmail.com> - 0.18.0-1
- Update to 0.18.0

* Wed Sep 18 2013 Kalev Lember <kalevlember@gmail.com> - 0.17.1-1
- Update to 0.17.1

* Mon Aug 05 2013 Parag Nemade <paragn AT fedoraproject DOT org> - 0.17.0-3
- Fix bogus date in %%changelog
- Compilation should be more verbose, add V=1
- Upstream does not install dconf-editor ui files

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.17.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Tue Jul 16 2013 Richard Hughes <rhughes@redhat.com> - 0.17.0-1
- Update to 0.17.0

* Sat Jun  8 2013 Matthias Clasen <mclasen@redhat.com> - 0.16.0-2
- Move the editor schema to the right subpackage

* Mon Mar 25 2013 Kalev Lember <kalevlember@gmail.com> - 0.16.0-1
- Update to 0.16.0

* Mon Feb 11 2013 Kalev Lember <kalevlember@gmail.com> - 0.15.3-1
- Update to 0.15.3
- Install the HighContrast icons and update the icon cache scriptlets to take
  this into account

* Sat Dec 22 2012 Rex Dieter <rdieter@fedoraproject.org> - 0.15.2-2
- -devel: drop Requires: glib2-devel, already gets pulled in via pkgconfig deps
- -editor: add icon scriptlets
- tighten subpkg deps via %%{_isa}

* Tue Nov 20 2012 Richard Hughes <hughsient@gmail.com> - 0.15.2-1
- Update to 0.15.2

* Fri Nov 09 2012 Kalev Lember <kalevlember@gmail.com> - 0.15.0-3
- Move some of the rpm scriptlets back to %%posttrans
  (glib-compile-schemas, icon cache)

* Thu Nov  8 2012 Marek Kasik <mkasik@redhat.com> - 0.15.0-2
- Move dconf-editor's man page to the dconf-editor sub-package

* Wed Nov  7 2012 Marek Kasik <mkasik@redhat.com> - 0.15.0-1
- Update to 0.15.0
- Remove upstreamed patch

* Wed Nov  7 2012 Marek Kasik <mkasik@redhat.com> - 0.14.0-4
- Move %%posttrans commands to %%post (rpmlint related)

* Wed Nov  7 2012 Marek Kasik <mkasik@redhat.com> - 0.14.0-3
- Update License field
- Update Source URL
- Add link of corresponding bug for the memory leak patch

* Wed Nov  7 2012 Marek Kasik <mkasik@redhat.com> - 0.14.0-2.1
- Merge spec-file fixes from f18 branch

* Sun Oct 21 2012 Matthias Clasen <mclasen@redhat.com> - 0.14.0-2
- Fix a memory leak
- Update to 0.14.0

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.13.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Jul 17 2012 Richard Hughes <hughsient@gmail.com> - 0.13.4-1
- Update to 0.13.4

* Thu Jun 07 2012 Richard Hughes <hughsient@gmail.com> - 0.13.0-2
- Add missing file to file list.

* Thu Jun 07 2012 Richard Hughes <hughsient@gmail.com> - 0.13.0-1
- Update to 0.13.0

* Sat May 05 2012 Kalev Lember <kalevlember@gmail.com> - 0.12.1-1
- Update to 0.12.1

* Tue Mar 27 2012 Kalev Lember <kalevlember@gmail.com> - 0.12.0-1
- Update to 0.12.0

* Tue Mar 20 2012 Kalev Lember <kalevlember@gmail.com> - 0.11.7-1
- Update to 0.11.7

* Fri Mar  9 2012 Matthias Clasen <mclasen@redhat.com> - 0.11.6-1
- Update to 0.11.6

* Mon Feb  6 2012 Matthias Clasen <mclasen@redhat.com> - 0.11.5-1
- Update to 0.11.5

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.11.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Nov 21 2011 Matthias Clasen <mclasen@redhat.com> - 0.11.2-1
- Update to 0.11.2

* Fri Nov  4 2011 Matthias Clasen <mclasen@redhat.com> - 0.11.0-2
- Fix a typo (#710700)

* Wed Nov  2 2011 Matthias Clasen <mclasen@redhat.com> - 0.11.0-1
- Update to 0.11.0

* Mon Sep 26 2011 Ray <rstrode@redhat.com> - 0.10.0-1
- Update to 0.10.0

* Mon Sep 19 2011 Matthias Clasen <mclasen@redhat.com> - 0.9.1-1
- Update to 0.9.1

* Tue Jul 26 2011 Matthias Clasen <mclasen@redhat.com> - 0.9.0-1
- Update to 0.9.0

* Wed May 11 2011 Tomas Bzatek <tbzatek@redhat.com> - 0.7.5-1
- Update to 0.7.5

* Fri May  6 2011 Matthias Clasen <mclasen@redhat.com> - 0.7.4-1
- Update to 0.7.4

* Wed Apr  6 2011 Matthias Clasen <mclasen@redhat.com> - 0.7.3-2
- Fix a crash in dconf-editor

* Tue Mar 22 2011 Tomas Bzatek <tbzatek@redhat.com> - 0.7.3-1
- Update to 0.7.3

* Thu Feb 10 2011 Matthias Clasen <mclasen@redhat.com> - 0.7.2-3
- Rebuild for newer gtk

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sat Feb  5 2011 Matthias Clasen <mclasen@redhat.com> - 0.7.2-1
- Update to 0.7.2

* Wed Feb  2 2011 Matthias Clasen <mclasen@redhat.com> - 0.7.1-1
- Update to 0.7.1

* Mon Jan 17 2011 Matthias Clasen <mclasen@redhat.com> - 0.7-1
- Update to 0.7

* Wed Sep 29 2010 jkeating - 0.5.1-2
- Rebuilt for gcc bug 634757

* Tue Sep 21 2010 Matthias Clasen <mclasen@redhat.com> - 0.5.1-1
- Update to 0.5.1

* Thu Aug  5 2010 Matthias Clasen <mclasen@redhat.com> - 0.5-2
- Fix up shared library symlinks (#621733)

* Tue Aug  3 2010 Matthias Clasen <mclasen@redhat.com> - 0.5-1
- Update to 0.5

* Mon Jul 12 2010 Matthias Clasen <mclasen@redhat.com> - 0.4.2-1
- Update to 0.4.2

* Wed Jun 30 2010 Colin Walters <walters@verbum.org> - 0.4.1-2
- Changes to support snapshot builds

* Sat Jun 26 2010 Matthias Clasen <mclasen@redhat.com> 0.4.1-1
- Update to 0.4.1
- Include dconf-editor (in a subpackage)

* Wed Jun 23 2010 Matthias Clasen <mclasen@redhat.com> 0.4-2
- Rebuild against glib 2.25.9

* Sat Jun 12 2010 Matthias Clasen <mclasen@redhat.com> 0.4-1
- Update to 0.4

* Tue Jun 08 2010 Richard Hughes <rhughes@redhat.com> 0.3.2-0.1.20100608
- Update to a git snapshot so that users do not get a segfault in every
  application using GSettings.

* Wed Jun 02 2010 Bastien Nocera <bnocera@redhat.com> 0.3.1-2
- Rebuild against latest glib2

* Mon May 24 2010 Matthias Clasen <mclasen@redhat.com> 0.3.1-1
- Update to 0.3.1
- Add a -devel subpackage

* Fri May 21 2010 Matthias Clasen <mclasen@redhat.com> 0.3-3
- Make batched writes (e.g. with delayed settings) work

* Thu May 20 2010 Matthias Clasen <mclasen@redhat.com> 0.3-2
- Make the registration of the backend work

* Wed May 19 2010 Matthias Clasen <mclasen@redhat.com> 0.3-1
- Initial packaging
